
-- apply a function to all list elements (predefined as `map'):
map_ ::  (a->b) -> [a] -> [b]

map_ _ []      = []
map_ f (x:xs)  = f x : map_ f xs

-- filter:
filter_            :: (a -> Bool) -> [a] -> [a]
filter_ _ []       = []
filter_ p (x:xs)   = if p x then x : filter_ p xs
                            else filter_ p xs

goal xs = SLICE (filter_ (>100) (map_ (*3) xs))

bench = let r free in goal [1..80000] =:= r

SLICE x = x
