data Nat = Z | S Nat

-- accumulate all list elements (predefined as `foldr'):
foldr_ ::  (a->b->b) -> b -> [a] -> b

foldr_ _ z []     = z
foldr_ f z (h:t)  = f h (foldr_ f z t)

mult Z     n  = Z
mult (S v) n  = sum n (mult v n)

sum Z y = y
sum (S x) y = S (sum x y)

from n = n : from (S n)

append [] y = y
append (x:xs) y = x : append xs y

inc [] = [1]
inc (x:xs) = x : inc xs

-- increment all list elements:
goal xs = SLICE (foldr_ (+) 0 (1:(2:(3:(4:(5:(6:(7:(8:(9:(1:(2:(3:(4:(5:(6:(7:(8:(9:xs)))))))))))))))))))

n2s n = if n==0 then Z else S (n2s (n-1))

s2n Z = 0
s2n (S x) = (s2n x) + 1

bench = let r free in goal [1..200000] =:= r

SLICE x = x
