data Nat = Z | S Nat

-- accumulate all list elements (predefined as `foldr'):
foldr_ ::  (a->b->b) -> b -> [a] -> b

foldr_ _ z []     = z
foldr_ f z (h:t)  = f h (foldr_ f z t)

-- concat:
app [] ys = ys
app (x:xs) ys = x : app xs ys

allones xs ys = ones (len (app xs ys))
ones Z = []
ones (S x) = 1 : ones x
len [] = Z
len (x:xs) = S (len xs)

goal xs = SLICE (foldr_ allones [] ((9:(9:(9:(9:(9:[]))))):xs))

bench = let r free in goal (map (\_->[9]) [1..2000]) =:= r

SLICE x = x
