data Nat = Z | S Nat

data Token = Cst Nat
           | Var Int 
           | Plus Token Token 
           | Minus Token Token 
           | Fun String

int (Cst x) _ _ = x
int (Var x) vars vals = lookup x vars vals
int (Plus x y) vars vals = sum (int x vars vals) (int y vars vals)
int (Minus x y)  vars vals = minus (int x vars vals) (int y vars vals)
int (Fun x) vars vals = int (def0 x) vars vals

sum Z y = y
sum (S x) y = S (sum x y)

minus x Z = x
minus (S x) (S y) = minus x y 

def0 One = Cst (S Z)
def0 Rec = Fun Rec

lookup x (v:vs) (val:vals) = if x==v
                                then val
                                else lookup x vs vals 

goal x = SLICE (int (Plus (Minus (Var 2) (Var 1))
                          (Plus (Minus (Var 4) (Var 3)) 
                                (Minus (Var 4) (Var 2)))) 
                    [1,2,3,4] x)

s2n Z = 0
s2n (S x) = (s2n x) + 1

bench = s2n (goal [S Z, S (S Z), S (S (S Z)), S (S (S (S Z)))])

SLICE x = x
