-- quicksort using higher-order functions:

app [] ys = ys
app (x:xs) ys = x : app xs ys

filter_            :: (a -> Bool) -> [a] -> [a]
filter_ _ []       = []
filter_ p (x:xs)   = if p x then x : filter_ p xs
                            else filter_ p xs

qsort :: [Int] -> [Int] 
qsort []     = []
qsort (x:l)  = app (qsort (filter (<x) l)) (x : qsort (filter_ (>=x) l))

goal xs = SLICE (qsort xs)

bench = let r free in goal [200,199..1] =:= r

SLICE x = x
